'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HasDropdown = exports.Dropdown = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _elementType = require('react-prop-types/lib/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

var _Overlay = require('react-overlays/lib/Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _RootCloseWrapper = require('react-overlays/lib/RootCloseWrapper');

var _RootCloseWrapper2 = _interopRequireDefault(_RootCloseWrapper);

var _isBlank = require('underscore.string/isBlank');

var _isBlank2 = _interopRequireDefault(_isBlank);

var _contains = require('dom-helpers/query/contains');

var _contains2 = _interopRequireDefault(_contains);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mouseOverOut(event, callback) {
  var target = event.currentTarget;
  var related = event.relatedTarget || event.nativeEvent.toElement;

  if (!related || related !== target && !(0, _contains2.default)(target, related)) {
    return callback(event);
  }
}

var Dropdown = exports.Dropdown = function (_Component) {
  (0, _inherits3.default)(Dropdown, _Component);

  function Dropdown() {
    (0, _classCallCheck3.default)(this, Dropdown);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Dropdown).apply(this, arguments));
  }

  (0, _createClass3.default)(Dropdown, [{
    key: 'render',
    value: function render() {
      var _cx;

      var _props = this.props;
      var className = _props.className;
      var position = _props.position;
      var size = _props.size;

      var classNames = (0, _classnames2.default)(className, _styles2.default['dropdown-pane'], _styles2.default['is-open'], (_cx = {}, (0, _defineProperty3.default)(_cx, _styles2.default[position], _constants.OVERLAY_POSITIONS.includes(position)), (0, _defineProperty3.default)(_cx, _styles2.default[size], _constants.COMPONENT_SIZES.includes(size)), _cx));

      return _react2.default.createElement('div', (0, _extends3.default)({}, this.props, { className: classNames }));
    }
  }]);
  return Dropdown;
}(_react.Component);

Dropdown.propTypes = {
  className: _react.PropTypes.string,
  position: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
  size: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES)
};


var HasDropdownBase = (0, _createHigherOrderComponent2.default)({
  displayName: 'HasDropdownBase',
  mapPropsToProps: function mapPropsToProps(_ref) {
    var dropdown = _ref.dropdown;
    var restProps = (0, _objectWithoutProperties3.default)(_ref, ['dropdown']);

    var props = (0, _extends3.default)({}, restProps, {
      'aria-haspopup': true
    });

    if (dropdown && dropdown.props && !(0, _isBlank2.default)(dropdown.props.id)) {
      props['aria-controls'] = dropdown.props.id;
    }

    return props;
  }
});

var HasDropdown = exports.HasDropdown = function (_Component2) {
  (0, _inherits3.default)(HasDropdown, _Component2);

  function HasDropdown(props) {
    (0, _classCallCheck3.default)(this, HasDropdown);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(HasDropdown).call(this, props));

    _this2.setTargetRef = function (ref) {
      return _this2._targetRef = ref;
    };

    _this2.getTargetRefDOMNode = function () {
      return (0, _reactDom.findDOMNode)(_this2._targetRef);
    };

    _this2.handleShow = function () {
      return _this2.setState({ show: true });
    };

    _this2.handleHide = function () {
      if (!_this2._clicked) {
        _this2.setState({ show: false });
      }
    };

    _this2.handleAnyClick = function () {
      var show = _this2.state.show;


      if (show) {
        if (_this2._clicked) {
          _this2._clicked = false;
          _this2.handleHide();
        } else {
          _this2._clicked = true;
        }
      } else {
        _this2._clicked = true;
        _this2.handleShow();
      }
    };

    _this2.handleRootClose = function () {
      var closeOnClick = _this2.props.closeOnClick;


      if (closeOnClick) {
        var now = new Date();
        var diff = now - _this2._lastRootClose;

        _this2._lastRootClose = now;

        if (_this2._clicked && diff < 50) {
          _this2.handleAnyClick();
        }
      }
    };

    _this2.handleClick = function () {
      var _this2$props = _this2.props;
      var onClick = _this2$props.onClick;
      var toggleClick = _this2$props.toggleClick;


      if (toggleClick) {
        _this2.handleAnyClick();

        if (onClick) {
          onClick.apply(undefined, arguments);
        }
      }
    };

    _this2.handleBlur = function () {
      var _this2$props2 = _this2.props;
      var onBlur = _this2$props2.onBlur;
      var toggleFocus = _this2$props2.toggleFocus;


      if (toggleFocus) {
        _this2.handleHide();

        if (onBlur) {
          onBlur.apply(undefined, arguments);
        }
      }
    };

    _this2.handleFocus = function () {
      var _this2$props3 = _this2.props;
      var onFocus = _this2$props3.onFocus;
      var toggleFocus = _this2$props3.toggleFocus;


      if (toggleFocus) {
        _this2.handleShow();

        if (onFocus) {
          onFocus.apply(undefined, arguments);
        }
      }
    };

    _this2.handleMouseOut = function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this2$props4 = _this2.props;
      var onMouseOut = _this2$props4.onMouseOut;
      var toggleHover = _this2$props4.toggleHover;


      if (toggleHover) {
        var event = args[0];


        mouseOverOut(event, function () {
          _this2.handleHide();

          if (onMouseOut) {
            onMouseOut.apply(undefined, args);
          }
        });
      }
    };

    _this2.handleMouseOver = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var _this2$props5 = _this2.props;
      var onMouseOver = _this2$props5.onMouseOver;
      var toggleHover = _this2$props5.toggleHover;
      var event = args[0];


      if (toggleHover) {
        mouseOverOut(event, function () {
          _this2.handleShow();

          if (onMouseOver) {
            onMouseOver.apply(undefined, args);
          }
        });
      }
    };

    _this2.createOverlay = function () {
      var _this2$props6 = _this2.props;
      var children = _this2$props6.children;
      var dropdown = _this2$props6.dropdown;
      var dropdownClassName = _this2$props6.dropdownClassName;
      var dropdownPosition = _this2$props6.dropdownPosition;
      var dropdownSize = _this2$props6.dropdownSize;
      var dropdownStyle = _this2$props6.dropdownStyle;
      var transition = _this2$props6.transition;
      var show = _this2.state.show;

      var placement = dropdownPosition || 'bottom';
      var labelledBy = null;

      if (children && children.props && !(0, _isBlank2.default)(children.props.id)) {
        labelledBy = children.props.id;
      }

      return _react2.default.createElement(
        _Overlay2.default,
        {
          onHide: _this2.handleRootClose,
          placement: placement,
          rootClose: true,
          show: show,
          target: _this2.getTargetRefDOMNode,
          transition: transition
        },
        _react2.default.createElement(
          Dropdown,
          {
            'aria-labelledby': labelledBy,
            className: dropdownClassName,
            position: dropdownPosition,
            size: dropdownSize,
            style: dropdownStyle
          },
          dropdown
        )
      );
    };

    _this2.renderOverlay = function () {
      return (0, _reactDom.unstable_renderSubtreeIntoContainer // eslint-disable-line camelcase
      )(_this2, _this2._overlay, _this2._mountNode);
    };

    _this2.state = {
      show: false
    };
    _this2._clicked = false;
    _this2._lastRootClose = new Date();
    return _this2;
  }

  (0, _createClass3.default)(HasDropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mountNode = document.createElement('div');
      this.renderOverlay();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this._mountNode) {
        this.renderOverlay();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _reactDom.unmountComponentAtNode)(this._mountNode);
      this._mountNode = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var show = this.state.show;


      this._overlay = this.createOverlay();

      return _react2.default.createElement(
        _RootCloseWrapper2.default,
        { noWrap: true, onRootClose: this.handleRootClose },
        _react2.default.createElement(HasDropdownBase, (0, _extends3.default)({}, this.props, {
          'aria-expanded': show,
          onBlur: this.handleBlur,
          onClick: this.handleClick,
          onFocus: this.handleFocus,
          onMouseOut: this.handleMouseOut,
          onMouseOver: this.handleMouseOver,
          ref: this.setTargetRef
        }))
      );
    }
  }]);
  return HasDropdown;
}(_react.Component);

HasDropdown.propTypes = {
  children: _react.PropTypes.node,
  closeOnClick: _react.PropTypes.bool,
  dropdown: _react.PropTypes.node,
  dropdownClassName: _react.PropTypes.string,
  dropdownPosition: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
  dropdownSize: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES),
  dropdownStyle: _react.PropTypes.object,
  onBlur: _react.PropTypes.func,
  onClick: _react.PropTypes.func,
  onFocus: _react.PropTypes.func,
  onMouseOut: _react.PropTypes.func,
  onMouseOver: _react.PropTypes.func,
  toggleClick: _react.PropTypes.bool,
  toggleFocus: _react.PropTypes.bool,
  toggleHover: _react.PropTypes.bool,
  transition: _elementType2.default
};
HasDropdown.defaultProps = {
  toggleClick: true
};