'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OffCanvasContainer = exports.OffCanvasContent = exports.OffCanvas = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OffCanvas = exports.OffCanvas = function (_Component) {
  (0, _inherits3.default)(OffCanvas, _Component);

  function OffCanvas() {
    (0, _classCallCheck3.default)(this, OffCanvas);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(OffCanvas).apply(this, arguments));
  }

  (0, _createClass3.default)(OffCanvas, [{
    key: 'render',
    value: function render() {
      var _cx;

      var _props = this.props;
      var className = _props.className;
      var position = _props.position;
      var revealForSize = _props.revealForSize;

      var classNames = (0, _classnames2.default)(className, _styles2.default['off-canvas'], (_cx = {}, (0, _defineProperty3.default)(_cx, _styles2.default['position-' + position], _constants.OFF_CANVAS_POSITIONS.includes(position)), (0, _defineProperty3.default)(_cx, _styles2.default['reveal-for-' + revealForSize], _constants.LARGER_SCREEN_SIZES.includes(revealForSize)), _cx));

      return _react2.default.createElement('div', (0, _extends3.default)({}, this.props, { className: classNames }));
    }
  }]);
  return OffCanvas;
}(_react.Component);

OffCanvas.propTypes = {
  className: _react.PropTypes.string,
  position: _react.PropTypes.oneOf(_constants.OFF_CANVAS_POSITIONS),
  revealForSize: _react.PropTypes.oneOf(_constants.LARGER_SCREEN_SIZES)
};

var OffCanvasContent = exports.OffCanvasContent = function (_Component2) {
  (0, _inherits3.default)(OffCanvasContent, _Component2);

  function OffCanvasContent() {
    var _Object$getPrototypeO;

    var _temp, _this2, _ret;

    (0, _classCallCheck3.default)(this, OffCanvasContent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(OffCanvasContent)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this2), _this2.handleContentBlockerClick = function () {
      var onContentBlockerClick = _this2.props.onContentBlockerClick;


      if (onContentBlockerClick) {
        onContentBlockerClick();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
  }

  (0, _createClass3.default)(OffCanvasContent, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var blocked = _props2.blocked;
      var children = _props2.children;
      var className = _props2.className;
      var contentBlockerClassName = _props2.contentBlockerClassName;
      var contentBlockerStyle = _props2.contentBlockerStyle;

      var classNames = (0, _classnames2.default)(className, _styles2.default['off-canvas-content']);
      var contentBlockerClassNames = (0, _classnames2.default)(contentBlockerClassName, _styles2.default['js-off-canvas-exit'], (0, _defineProperty3.default)({}, _styles2.default['is-visible'], blocked));

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, this.props, { className: classNames }),
        children,
        _react2.default.createElement('div', {
          className: contentBlockerClassNames,
          onClick: this.handleContentBlockerClick,
          style: contentBlockerStyle
        })
      );
    }
  }]);
  return OffCanvasContent;
}(_react.Component);

OffCanvasContent.propTypes = {
  blocked: _react.PropTypes.bool,
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  contentBlockerClassName: _react.PropTypes.string,
  contentBlockerStyle: _react.PropTypes.object,
  onContentBlockerClick: _react.PropTypes.func
};

var OffCanvasContainer = exports.OffCanvasContainer = function (_Component3) {
  (0, _inherits3.default)(OffCanvasContainer, _Component3);

  function OffCanvasContainer() {
    (0, _classCallCheck3.default)(this, OffCanvasContainer);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(OffCanvasContainer).apply(this, arguments));
  }

  (0, _createClass3.default)(OffCanvasContainer, [{
    key: 'render',
    value: function render() {
      var _props3 = this.props;
      var children = _props3.children;
      var className = _props3.className;
      var innerClassName = _props3.innerClassName;
      var innerStyle = _props3.innerStyle;
      var open = _props3.open;

      var openValid = _constants.OFF_CANVAS_POSITIONS.includes(open);
      var classNames = (0, _classnames2.default)(className, _styles2.default['off-canvas-wrapper']);
      var innerClassNames = (0, _classnames2.default)(innerClassName, _styles2.default['off-canvas-wrapper-inner'], (0, _defineProperty3.default)({}, _styles2.default['is-open-' + open], openValid));
      var newChildren = _react.Children.map(children, function (child) {
        if ((0, _react.isValidElement)(child) && child.type === OffCanvasContent) {
          return (0, _react.cloneElement)(child, { blocked: openValid });
        }

        return child;
      });

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, this.props, { className: classNames }),
        _react2.default.createElement(
          'div',
          { className: innerClassNames, style: innerStyle },
          newChildren
        )
      );
    }
  }]);
  return OffCanvasContainer;
}(_react.Component);

OffCanvasContainer.propTypes = {
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  innerClassName: _react.PropTypes.string,
  innerStyle: _react.PropTypes.object,
  open: _react.PropTypes.oneOf(_constants.OFF_CANVAS_POSITIONS)
};