'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ClearFix = exports.Float = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Float = exports.Float = (0, _createHigherOrderComponent2.default)({
  displayName: 'Float',
  propTypes: {
    position: _react.PropTypes.oneOf(_constants.FLOAT_POSITIONS).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref) {
    var position = _ref.position;
    return (0, _defineProperty3.default)({}, _styles2.default['float-' + position], _constants.FLOAT_POSITIONS.includes(position));
  }
});

var ClearFix = exports.ClearFix = (0, _createHigherOrderComponent2.default)({
  displayName: 'ClearFix',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return _styles2.default.clearfix;
  },
  defaultComponentClass: 'div',
  collapseOnlyChild: false
});