'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.Row = undefined;

var _react = require('react');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _grid = require('../../util/grid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rowPropTypes = (0, _grid.createScreenSizePropTypes)(_constants.FLOAT_GRID_ROW_CLASS_NAMES);
var columnPropTypes = (0, _grid.createScreenSizePropTypes)(_constants.FLOAT_GRID_COLUMN_CLASS_NAMES);

rowPropTypes.expanded = _react.PropTypes.bool;
columnPropTypes.end = _react.PropTypes.bool;

var Row = exports.Row = (0, _createHigherOrderComponent2.default)({
  displayName: 'Row',
  propTypes: rowPropTypes,
  mapPropsToClassNames: function mapPropsToClassNames(props) {
    var expanded = props.expanded;

    var classNames = (0, _grid.createScreenSizeClassNamesFromProps)(_constants.FLOAT_GRID_ROW_CLASS_NAMES, props, _styles2.default);

    classNames[_styles2.default.row] = true;
    classNames[_styles2.default.expanded] = expanded;

    return classNames;
  },
  defaultComponentClass: 'div',
  collapseOnlyChild: false
});

var Column = exports.Column = (0, _createHigherOrderComponent2.default)({
  displayName: 'Column',
  propTypes: columnPropTypes,
  mapPropsToClassNames: function mapPropsToClassNames(props) {
    var end = props.end;

    var classNames = (0, _grid.createScreenSizeClassNamesFromProps)(_constants.FLOAT_GRID_COLUMN_CLASS_NAMES, props, _styles2.default);

    classNames[_styles2.default.column] = true;
    classNames[_styles2.default.end] = end;

    return classNames;
  },
  defaultComponentClass: 'div',
  collapseOnlyChild: false
});