'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ShowOnlyOnFocus = exports.HideOnlyForScreenReader = exports.ShowOnlyForScreenReader = exports.HideForScreenOrientation = exports.ShowForScreenOrientation = exports.Invisible = exports.Hide = exports.HideOnlyForScreenSize = exports.HideForScreenSize = exports.ShowOnlyForScreenSize = exports.ShowForScreenSize = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _constants = require('../../util/constants');

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ShowForScreenSize = exports.ShowForScreenSize = (0, _createHigherOrderComponent2.default)({
  displayName: 'ShowForScreenSize',
  propTypes: {
    size: _react.PropTypes.oneOf(_constants.LARGER_SCREEN_SIZES).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref) {
    var size = _ref.size;
    return (0, _defineProperty3.default)({}, _styles2.default['show-for-' + size], _constants.LARGER_SCREEN_SIZES.includes(size));
  }
});

var ShowOnlyForScreenSize = exports.ShowOnlyForScreenSize = (0, _createHigherOrderComponent2.default)({
  displayName: 'ShowOnlyForScreenSize',
  propTypes: {
    size: _react.PropTypes.oneOf(_constants.SCREEN_SIZES).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref3) {
    var size = _ref3.size;
    return (0, _defineProperty3.default)({}, _styles2.default['show-for-' + size + '-only'], _constants.SCREEN_SIZES.includes(size));
  }
});

var HideForScreenSize = exports.HideForScreenSize = (0, _createHigherOrderComponent2.default)({
  displayName: 'HideForScreenSize',
  propTypes: {
    size: _react.PropTypes.oneOf(_constants.LARGER_SCREEN_SIZES).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref5) {
    var size = _ref5.size;
    return (0, _defineProperty3.default)({}, _styles2.default['hide-for-' + size], _constants.LARGER_SCREEN_SIZES.includes(size));
  }
});

var HideOnlyForScreenSize = exports.HideOnlyForScreenSize = (0, _createHigherOrderComponent2.default)({
  displayName: 'HideOnlyForScreenSize',
  propTypes: {
    size: _react.PropTypes.oneOf(_constants.SCREEN_SIZES).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref7) {
    var size = _ref7.size;
    return (0, _defineProperty3.default)({}, _styles2.default['hide-for-' + size + '-only'], _constants.SCREEN_SIZES.includes(size));
  }
});

var Hide = exports.Hide = (0, _createHigherOrderComponent2.default)({
  displayName: 'Hide',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _defineProperty3.default)({}, _styles2.default.hide, true);
  }
});

var Invisible = exports.Invisible = (0, _createHigherOrderComponent2.default)({
  displayName: 'Invisible',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _defineProperty3.default)({}, _styles2.default.invisible, true);
  }
});

var ShowForScreenOrientation = exports.ShowForScreenOrientation = (0, _createHigherOrderComponent2.default)({
  displayName: 'ShowForScreenOrientation',
  propTypes: {
    orientation: _react.PropTypes.oneOf(_constants.SCREEN_ORIENTATIONS).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref11) {
    var orientation = _ref11.orientation;
    return (0, _defineProperty3.default)({}, _styles2.default['show-for-' + orientation], _constants.SCREEN_ORIENTATIONS.includes(orientation));
  }
});

var HideForScreenOrientation = exports.HideForScreenOrientation = (0, _createHigherOrderComponent2.default)({
  displayName: 'HideForScreenOrientation',
  propTypes: {
    orientation: _react.PropTypes.oneOf(_constants.SCREEN_ORIENTATIONS).isRequired
  },
  mapPropsToClassNames: function mapPropsToClassNames(_ref13) {
    var orientation = _ref13.orientation;
    return (0, _defineProperty3.default)({}, _styles2.default['hide-for-' + orientation], _constants.SCREEN_ORIENTATIONS.includes(orientation));
  }
});

var ShowOnlyForScreenReader = exports.ShowOnlyForScreenReader = (0, _createHigherOrderComponent2.default)({
  displayName: 'ShowOnlyForScreenReader',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _defineProperty3.default)({}, _styles2.default['show-for-sr'], true);
  }
});

var HideOnlyForScreenReader = exports.HideOnlyForScreenReader = (0, _createHigherOrderComponent2.default)({
  displayName: 'HideOnlyForScreenReader',
  mapPropsToProps: function mapPropsToProps(props) {
    return (0, _extends3.default)({}, props, {
      'aria-hidden': true
    });
  }
});

var ShowOnlyOnFocus = exports.ShowOnlyOnFocus = (0, _createHigherOrderComponent2.default)({
  displayName: 'ShowOnlyOnFocus',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return (0, _defineProperty3.default)({}, _styles2.default['show-on-focus'], true);
  }
});