'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Statistic = exports.UnbulletedList = exports.Lead = exports.Subheader = undefined;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _createHigherOrderComponent = require('../../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Subheader = exports.Subheader = (0, _createHigherOrderComponent2.default)({
  displayName: 'Subheader',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return _styles2.default.subheader;
  }
});

var Lead = exports.Lead = (0, _createHigherOrderComponent2.default)({
  displayName: 'Lead',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return _styles2.default.lead;
  }
});

var UnbulletedList = exports.UnbulletedList = (0, _createHigherOrderComponent2.default)({
  displayName: 'UnbulletedList',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return _styles2.default['no-bullet'];
  },
  defaultComponentClass: 'ul',
  collapseOnlyChild: false
});

var Statistic = exports.Statistic = (0, _createHigherOrderComponent2.default)({
  displayName: 'Statistic',
  mapPropsToClassNames: function mapPropsToClassNames() {
    return _styles2.default.stat;
  }
});