'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SCREEN_SIZES = exports.SCREEN_SIZES = ['small', 'medium', 'large', 'xlarge', 'xxlarge'];
var SMALLER_SCREEN_SIZES = exports.SMALLER_SCREEN_SIZES = SCREEN_SIZES.slice(0, 1);
var LARGER_SCREEN_SIZES = exports.LARGER_SCREEN_SIZES = SCREEN_SIZES.slice(1);

var SCREEN_ORIENTATIONS = exports.SCREEN_ORIENTATIONS = ['landscape', 'portrait'];

var COMPONENT_COLORS = exports.COMPONENT_COLORS = ['primary', 'secondary', 'success', 'alert', 'warning'];

var COMPONENT_SIZES = exports.COMPONENT_SIZES = ['tiny', 'small', 'large'];
var CALLOUT_SIZES = exports.CALLOUT_SIZES = COMPONENT_SIZES.filter(function (size) {
  return size !== 'tiny';
});
var MODAL_SIZES = exports.MODAL_SIZES = COMPONENT_SIZES.concat(['full']);

var MEDIA_OBJECT_SECTION_ALIGNMENTS = exports.MEDIA_OBJECT_SECTION_ALIGNMENTS = ['middle', 'bottom'];

var OFF_CANVAS_POSITIONS = exports.OFF_CANVAS_POSITIONS = ['left', 'right'];
var TITLE_BAR_POSITIONS = exports.TITLE_BAR_POSITIONS = OFF_CANVAS_POSITIONS;
var OVERLAY_POSITIONS = exports.OVERLAY_POSITIONS = OFF_CANVAS_POSITIONS.concat(['top']);
var FLOAT_POSITIONS = exports.FLOAT_POSITIONS = OFF_CANVAS_POSITIONS.concat(['center']);
var TEXT_ALIGNMENTS = exports.TEXT_ALIGNMENTS = FLOAT_POSITIONS.concat(['justify']);

var GRID_COLUMN_MIN = exports.GRID_COLUMN_MIN = 1;
var GRID_COLUMN_MAX = exports.GRID_COLUMN_MAX = 12;
var FLOAT_GRID_ROW_CLASS_NAMES = exports.FLOAT_GRID_ROW_CLASS_NAMES = {
  collapse: {
    basePropName: 'Collapse',
    isNumber: false,
    skipSmall: false
  },
  uncollapse: {
    basePropName: 'Uncollapse',
    isNumber: false,
    skipSmall: false
  },
  up: {
    basePropName: 'Up',
    isNumber: true,
    skipSmall: false
  }
};
var FLOAT_GRID_COLUMN_CLASS_NAMES = exports.FLOAT_GRID_COLUMN_CLASS_NAMES = {
  '': {
    basePropName: '',
    isNumber: true,
    skipSmall: false
  },
  offset: {
    basePropName: 'Offset',
    isNumber: true,
    skipSmall: false
  },
  centered: {
    basePropName: 'Centered',
    isNumber: false,
    skipSmall: false
  },
  uncentered: {
    basePropName: 'Uncentered',
    isNumber: false,
    skipSmall: false
  },
  push: {
    basePropName: 'Push',
    isNumber: true,
    skipSmall: false
  },
  pull: {
    basePropName: 'Pull',
    isNumber: true,
    skipSmall: false
  }
};
var FLEX_GRID_ROW_CLASS_NAMES = exports.FLEX_GRID_ROW_CLASS_NAMES = {
  unstack: {
    basePropName: 'Unstack',
    isNumber: false,
    skipSmall: true
  },
  collapse: {
    basePropName: 'Collapse',
    isNumber: false,
    skipSmall: false
  },
  uncollapse: {
    basePropName: 'Uncollapse',
    isNumber: false,
    skipSmall: false
  }
};
var FLEX_GRID_COLUMN_CLASS_NAMES = exports.FLEX_GRID_COLUMN_CLASS_NAMES = {
  '': {
    basePropName: '',
    isNumber: true,
    skipSmall: false
  },
  expand: {
    basePropName: 'Expand',
    isNumber: false,
    skipSmall: true
  },
  offset: {
    basePropName: 'Offset',
    isNumber: true,
    skipSmall: false
  },
  order: {
    basePropName: 'Order',
    isNumber: true,
    skipSmall: false
  }
};
var FLEX_GRID_HORIZONTAL_ALIGNMENTS = exports.FLEX_GRID_HORIZONTAL_ALIGNMENTS = ['right', 'center', 'justify', 'spaced'];
var FLEX_GRID_VERTICAL_ALIGNMENTS = exports.FLEX_GRID_VERTICAL_ALIGNMENTS = ['top', 'middle', 'bottom', 'stretch'];